#!/usr/bin/ruby
#
# itunes2wassr.rb - Post the title playing by iTunes to Wassr.
#
# Copyright (c) 2008	Hiroaki Abe <hiroaki-sns@home.group.jp>
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.

# THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.


require 'win32ole'
require 'dl/win32'
require 'kconv'
require 'uri'
require 'net/http'

Net::HTTP.version_1_2
$KCODE='s'

$wassr_id=nil
$wassr_pw=nil
$wassr_ch='bgm'

#####################
ARGV.each {|argv|
  case argv
  when /^-id=(\w+$)/
    $wassr_id=$1
    
  when /^-pw=(\w+$)/
    $wassr_pw=$1
    
  when /^-ch=(\w+$)/
    $wassr_ch=$1

  end
}
  
if $wassr_id.nil? or $wassr_pw.nil?
  #
  mb = Win32API.new("user32","MessageBoxA",'LPPL',"L")
  mb.call(0,"#{$0} -id=OCID -pw=pX[h [-ch=`l]", "g", 0)
  exit
end

#####################
itunes = WIN32OLE.new('iTunes.Application')
ev = WIN32OLE_EVENT.new(itunes, '_IiTunesEvents')

def post_wassr(msg)
  req = Net::HTTP::Post.new("/channel_message/update.json?name_en=#{URI.encode($wassr_ch)}&body=#{URI.encode(msg)}")
  req.basic_auth $wassr_id, $wassr_pw
  begin
    Net::HTTP.start('api.wassr.jp', 80) {|http|
      res = http.request(req)
    }
  rescue
    #
  end
end

def current_play(ct)
  if ct.nil?
    return
  end

  msg = "#{ct.Name.toutf8}\n#{ct.Artist.toutf8}  - #{ct.Album.toutf8}\n"
  post_wassr msg
end

ev.on_event("OnPlayerPlayEvent") { |track|
  current_play(track)
  WIN32OLE_EVENT.message_loop
}

ev.on_event("OnAboutToPromptUserToQuitEvent") {
  itunes.Pause()
  WIN32OLE_EVENT.message_loop
  itunes = nil
  WIN32OLE_EVENT.message_loop
  exit
}

ev.on_event("OnQuittingEvent") {
  itunes.Pause()
  WIN32OLE_EVENT.message_loop
  itunes = nil
  WIN32OLE_EVENT.message_loop
  exit
}

current_play(itunes.CurrentTrack())

loop do
  WIN32OLE_EVENT.message_loop
  sleep 1
end
